<template src="./template.html"></template>

<script lang="ts">
import { Component, Vue } from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { trackEventAddToCart } from "~/utils/trackEvent";
var moment = require("moment");
@Component({
  components: {},
})
export default class CheckOrderComponent extends Vue {
  loadingTable = false;
  loading = false;
  loadingCancel = false;
  orderCode: any = "";
  listOrderTracking = [];
  order = {};
  email: any = "";

  isError = false;

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  mounted() {
    const { order_code, email } = this.$route.query;
    if (order_code) {
      this.orderCode = order_code;
    }
    if (email) {
      this.email = email;
    }
    this.listOrderTracking =
      //@ts-ignore
      JSON.parse(localStorage.getItem("listOrderTracking")) || [];
    if (this.orderCode) {
      this.onCheck();
    }
    // trackEventAddToCart(this);
  }

  async onCheck() {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      if (!this.orderCode || !this.email) {
        return this.$pushNotification.error(
          "Please enter order code and email"
        );
      }
      this.isError = false;
      this.loading = true;
      const response = await this.$api.order.getMyOrder(
        this.email,
        this.orderCode,
        this.slug
      );
      if (response.data === null) {
        this.isError = true;
        this.notification = true;
      }
      if (response.data) {
        this.order = response.data;
        const listOrderTracking =
          //@ts-ignore
          JSON.parse(localStorage.getItem("listOrderTracking"));
        if (!listOrderTracking) {
          localStorage.setItem(
            "listOrderTracking",
            JSON.stringify([this.orderCode])
          );
        } else {
          let parseListOrderTracking = [...listOrderTracking, this.orderCode];
          parseListOrderTracking = this.$utils.uniq(parseListOrderTracking);
          localStorage.setItem(
            "listOrderTracking",
            //@ts-ignore
            JSON.stringify(parseListOrderTracking)
          );
        }
        this.$router.push(
          `/pages/track/find?email=${
            this.email
          }&order_code=${this.orderCode.replace("#", "")}`
        );
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onCancelOrder() {
    try {
      this.loadingCancel = true;
      //@ts-ignore
      await this.$api.order.cancelOrder(this.orderCode.replace("#", ""));
      this.onCheck();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingCancel = false;
    }
  }

  onHandleSearch(orderCode: string) {
    this.orderCode = `${orderCode}`;
    this.onCheck();
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  notification = false;
  closeNotification() {
    this.notification = false;
  }

  get slug() {
    return this.$store.state.product?.slug || "";
  }
}
</script>

<style src="./style.css"></style>
<style lang="scss" scoped>
.track-container {
  padding: 90px 0;

  .title {
    font-size: 2rem !important;
    margin-bottom: 5rem;
    text-align: center;
  }

  .notification {
    background: #f5f5f5;
    transition: 0.3s ease;
    pointer-events: auto;
    overflow: hidden;
    padding: 6px;
    margin: 0 12px 15px;
    max-height: 100px;
    border-radius: 3px 3px 3px 3px;
    box-shadow: 0 0 10px #999;
    color: #000;
    opacity: 0.9;
    background-position: 15px;
    background-repeat: no-repeat;

    &:hover {
      box-shadow: unset !important;
    }

    h4 {
      color: red;
    }

    p {
      margin: 0;
    }

    .close-btn {
      background: rgba(10, 10, 10, 0.3);
      font-weight: 600;
      color: white;
      font-size: 12px;
      width: 20px;
      height: 20px;
      border-radius: 100%;
      display: flex;
      justify-content: center;
      align-items: center;
      z-index: 1;
    }
  }
}
</style>
